# Managed API for Microsoft Graph
Managed API for Microsoft Graph is an API Client for Microsoft Graph by [Adaptavist](https://www.adaptavist.com/) primarily designed for the use in [ScriptRunner Connect](https://scriptrunnerconnect.com). You can read more about Managed APIs [here](https://docs.adaptavist.com/src/managed-apis).

This is a runtime agnostic version of the Managed API (with `core` suffix) that makes it easy to port it to any runtime you may want to use this Managed API on.

# Platform specific ports
- [ScriptRunner Connect](https://www.npmjs.com/package/@managed-api/microsoft-graph-v1-sr-connect)

# Supported API calls
- [fetch](https://docs.adaptavist.com/src/managed-apis/managed-api-abstractions)
- Groups
    - [getGroups](https://learn.microsoft.com/en-us/graph/teams-list-all-teams?context=graph%2Fapi%2F1.0&view=graph-rest-1.0)
- Teams
    - Messaging
        - Channel
            - [addMember](https://learn.microsoft.com/en-us/graph/api/channel-post-members?view=graph-rest-1.0&tabs=http)
            - [createChannel](https://learn.microsoft.com/en-us/graph/api/channel-post?view=graph-rest-1.0&tabs=http)
            - [deleteChannel](https://learn.microsoft.com/en-us/graph/api/channel-delete?view=graph-rest-1.0&tabs=http)
            - [getChannel](https://learn.microsoft.com/en-us/graph/api/channel-get?view=graph-rest-1.0&tabs=http)
            - [getChannels](https://learn.microsoft.com/en-us/graph/api/channel-list?view=graph-rest-1.0&tabs=http)
            - [getMembers](https://learn.microsoft.com/en-us/graph/api/channel-list-members?view=graph-rest-1.0&tabs=http)
            - [getMessage](https://learn.microsoft.com/en-us/graph/api/chatmessage-get?view=graph-rest-1.0&tabs=http)
            - [getMessageReplies](https://learn.microsoft.com/en-us/graph/api/chatmessage-list-replies?view=graph-rest-1.0&tabs=http)
            - [getMessages](https://learn.microsoft.com/en-us/graph/api/channel-list-messages?view=graph-rest-1.0&tabs=http)
            - [removeMember](https://learn.microsoft.com/en-us/graph/api/channel-delete-members?view=graph-rest-1.0&tabs=http)
            - [replyToMessage](https://learn.microsoft.com/en-us/graph/api/chatmessage-post-replies?view=graph-rest-1.0&tabs=http)
            - [sendMessage](https://learn.microsoft.com/en-us/graph/api/channel-post-messages?view=graph-rest-1.0&tabs=http)
            - [updateChannel](https://learn.microsoft.com/en-us/graph/api/channel-patch?view=graph-rest-1.0&tabs=http)
            - [updateMessage](https://learn.microsoft.com/en-us/graph/api/chatmessage-update?view=graph-rest-1.0&tabs=http)
        - Chat
            - [addMember](https://learn.microsoft.com/en-us/graph/api/chat-post-members?view=graph-rest-1.0&tabs=http)
            - [createChat](https://learn.microsoft.com/en-us/graph/api/chat-post?view=graph-rest-1.0&tabs=http)
            - [getChat](https://learn.microsoft.com/en-us/graph/api/chat-get?view=graph-rest-1.0&tabs=http)
            - [getChats](https://learn.microsoft.com/en-us/graph/api/chat-list?view=graph-rest-1.0&tabs=http)
            - [getMember](https://learn.microsoft.com/en-us/graph/api/chat-get-members?view=graph-rest-1.0&tabs=http)
            - [getMembers](https://learn.microsoft.com/en-us/graph/api/chat-list-members?view=graph-rest-1.0&tabs=http)
            - [getMessage](https://learn.microsoft.com/en-us/graph/api/chatmessage-get?view=graph-rest-1.0&tabs=http)
            - [getMessages](https://learn.microsoft.com/en-us/graph/api/chat-list-messages?view=graph-rest-1.0&tabs=http)
            - [removeMember](https://learn.microsoft.com/en-us/graph/api/chat-delete-members?view=graph-rest-1.0&tabs=http)
            - [sendMessage](https://learn.microsoft.com/en-us/graph/api/chat-post-messages?view=graph-rest-1.0&tabs=http)
            - [updateChat](https://learn.microsoft.com/en-us/graph/api/chat-patch?view=graph-rest-1.0&tabs=http)
            - [updateMessage](https://learn.microsoft.com/en-us/graph/api/chatmessage-update?view=graph-rest-1.0&tabs=http)
    - Team
        - [addMember](https://learn.microsoft.com/en-us/graph/api/team-post-members?view=graph-rest-1.0&tabs=http)
        - [createTeam](https://learn.microsoft.com/en-us/graph/api/team-post?view=graph-rest-1.0&tabs=http)
        - [deleteTeam](https://learn.microsoft.com/en-us/graph/api/group-delete?view=graph-rest-1.0&tabs=http)
        - [getMember](https://learn.microsoft.com/en-us/graph/api/team-get-members?view=graph-rest-1.0&tabs=http)
        - [getMembers](https://learn.microsoft.com/en-us/graph/api/team-list-members?view=graph-rest-1.0&tabs=http)
        - [getMyTeams](https://learn.microsoft.com/en-us/graph/api/user-list-joinedteams?view=graph-rest-1.0&tabs=http)
        - [getTeam](https://learn.microsoft.com/en-us/graph/api/team-get?view=graph-rest-1.0&tabs=http)
        - [getUserAssociatedTeams](https://learn.microsoft.com/en-us/graph/api/associatedteaminfo-list?view=graph-rest-1.0&tabs=http)
        - [getUserTeams](https://learn.microsoft.com/en-us/graph/api/user-list-joinedteams?view=graph-rest-1.0&tabs=http)
        - [removeMember](https://learn.microsoft.com/en-us/graph/api/team-delete-members?view=graph-rest-1.0&tabs=http)
        - [updateMember](https://learn.microsoft.com/en-us/graph/api/team-update-members?view=graph-rest-1.0&tabs=http)
        - [updateTeam](https://learn.microsoft.com/en-us/graph/api/team-update?view=graph-rest-1.0&tabs=http)
- Users
    - [createUser](https://learn.microsoft.com/en-us/graph/api/user-post-users?view=graph-rest-1.0&tabs=http)
    - [deleteUser](https://learn.microsoft.com/en-us/graph/api/user-delete?view=graph-rest-1.0&tabs=http)
    - [getMyUser](https://learn.microsoft.com/en-us/graph/api/user-get?view=graph-rest-1.0&tabs=http)
    - [getUser](https://learn.microsoft.com/en-us/graph/api/user-get?view=graph-rest-1.0&tabs=http)
    - [getUsers](https://learn.microsoft.com/en-us/graph/api/user-list?view=graph-rest-1.0&tabs=http)
    - [updateUser](https://learn.microsoft.com/en-us/graph/api/user-update?view=graph-rest-1.0&tabs=http)


# Porting to other runtimes
While the primary reason for creating Managed APIs was to use them in [ScriptRunner Connect](https://scriptrunnerconnect.com) runtime, then you can easily port them to any runtime of your choosing.

You can do so by extending the `*Core` Managed API class where you'll be asked to provide implementation for `getPlatformImplementation` function. In this implementation you have to specify how to perform buffer encoding/decoding operations and how to perform HTTP calls:
```typescript
{
    buffer: {
        encode(input: string): ArrayBuffer;
        decode(input: ArrayBuffer): string;
    },
    performHttpCall(request: Request): Promise<Response>
}
```

Here is an example how to create a [Node](https://nodejs.org/en/) port of the Managed API:
```typescript
import { MicrosoftGraphApiCore } from "@managed-api/microsoft-graph-v1-core";
import { PlatformImplementation, Request, Response, Headers } from "@managed-api/commons-core";
import fetch from "node-fetch";

export class MicrosoftGraphApi extends MicrosoftGraphApiCore {
    constructor(private baseUrl: string, private authToken: string) {
        super();
    }

    protected getPlatformImplementation(): PlatformImplementation {
        return {
            buffer: {
                encode: (input) => Buffer.from(input, 'utf-8'),
                decode: (input) => Buffer.from(input).toString('utf-8')
            },
            performHttpCall: (request) => this.performHttpCall(request)
        };
    }
    
    private async performHttpCall(request: Request): Promise<Response> {
        const requestUrl = `${this.baseUrl}${request.url}`; // Substitute base URL
        request.headers.set('Authorization', `Basic ${this.authToken}`); // Substitute auth token
        const response = await fetch(requestUrl, {
            method: request.method,
            headers: request.headers as any,
            body: request.method.toLowerCase() !== 'get' ? Buffer.from((await request.arrayBuffer()) ?? new ArrayBuffer(0)) : undefined
        });

        const apiHeaders = new Headers();
        response.headers.forEach((value, key) => apiHeaders.append(key, value));

        const body = await response.arrayBuffer();

        return super.buildResponse(response.url, response.status, response.statusText, apiHeaders, body);
    }
}
```

Please note that the authentication handling details may not be accurate and serve as an example. If you wish to use these Managed APIs without having to concern yourself how to deal with and secure authentication details when working with APIs, then feel free to evaluate [ScriptRunner Connect](https://scriptrunnerconnect.com) platform.

# Contact
At this time Managed APIs are unlicensed and close sourced, but feel free to drop an email to [eknoll@adaptavist.com](mailto://eknoll@adaptavist.com) for ideas, suggestions and improvements.

 # Changelog
# 2.1.0

- Removed non-empty body from HEAD requests.

# 2.0.0

- # Breaking change: URL and query string parameters are now URL encoded, meaning if you encoded them explicitly before you have to remove your own encoding, otherwise they will get double encoded.

# 0.2.0

# Added support for the following Users methods:

-   [List users](https://learn.microsoft.com/en-us/graph/api/user-list?view=graph-rest-1.0&tabs=http) that can be used as `Users.getUsers` or `All.getUsers`.
-   [Create user](https://learn.microsoft.com/en-us/graph/api/user-post-users?view=graph-rest-1.0&tabs=http) that can be used as `Users.createUser` or `All.createUser`.
-   [Get user](https://learn.microsoft.com/en-us/graph/api/user-get?view=graph-rest-1.0&tabs=http) that can be used as `Users.getUser` or `All.getUser`.
-   [Get user](https://learn.microsoft.com/en-us/graph/api/user-get?view=graph-rest-1.0&tabs=http) that can be used as `Users.getMyUser` or `All.getMyUser`.
-   [Update user](https://learn.microsoft.com/en-us/graph/api/user-update?view=graph-rest-1.0&tabs=http) that can be used as `Users.updateUser` or `All.updateUser`.
-   [Delete a user](https://learn.microsoft.com/en-us/graph/api/user-delete?view=graph-rest-1.0&tabs=http) that can be used as `Users.deleteUser` or `All.deleteUser`.

# Added support for the following Teams.Team methods:

-   [Create team](https://learn.microsoft.com/en-us/graph/api/team-post?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Team.createTeam` or `All.createTeamsTeam`.
-   [Get team](https://learn.microsoft.com/en-us/graph/api/team-get?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Team.getTeam` or `All.getTeamsTeam`.
-   [Update team](https://learn.microsoft.com/en-us/graph/api/team-update?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Team.updateTeam` or `All.updateTeamsTeam`.
-   [Delete group](https://learn.microsoft.com/en-us/graph/api/group-delete?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Team.deleteTeam` or `All.deleteTeamsTeam`.
-   [List members of team](https://learn.microsoft.com/en-us/graph/api/team-list-members?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Team.getMembers` or `All.getTeamsTeamMembers`.
-   [Add member to team](https://learn.microsoft.com/en-us/graph/api/team-post-members?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Team.addMember` or `All.addTeamsTeamMember`.
-   [Get member of team](https://learn.microsoft.com/en-us/graph/api/team-get-members?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Team.getMember` or `All.getTeamsTeamMember`.
-   [Remove member from team](https://learn.microsoft.com/en-us/graph/api/team-delete-members?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Team.removeMember` or `All.removeTeamsTeamMember`.
-   [Update member in team](https://learn.microsoft.com/en-us/graph/api/team-update-members?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Team.updateMember` or `All.updateTeamsTeamMember`.
-   [List joinedTeams](https://learn.microsoft.com/en-us/graph/api/user-list-joinedteams?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Team.getMyTeams` or `All.getMyTeams`.
-   [List joinedTeams](https://learn.microsoft.com/en-us/graph/api/user-list-joinedteams?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Team.getUserTeams` or `All.getUserTeams`.
-   [List associatedTeamInfo](https://learn.microsoft.com/en-us/graph/api/associatedteaminfo-list?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Team.getUserAssociatedTeams` or `All.getUserAssociatedTeams`.
-   [List all teams in Microsoft Teams for an organization](https://learn.microsoft.com/en-us/graph/teams-list-all-teams?context=graph%2Fapi%2F1.0&view=graph-rest-1.0) that can be used as `Groups.getGroups` or `All.getGroups`.

# Added support for the following Teams.Messaging.Channel methods:

-   [List channels](https://learn.microsoft.com/en-us/graph/api/channel-list?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Channel.getChannels` or `All.getTeamsChannels`.
-   [Create channel](https://learn.microsoft.com/en-us/graph/api/channel-post?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Channel.createChannel` or `All.createTeamsChannel`.
-   [Get channel](https://learn.microsoft.com/en-us/graph/api/channel-get?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Channel.getChannel` or `All.getTeamsChannel`.
-   [Patch channel](https://learn.microsoft.com/en-us/graph/api/channel-patch?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Channel.updateChannel` or `All.updateTeamsChannel`.
-   [Delete channel](https://learn.microsoft.com/en-us/graph/api/channel-delete?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Channel.deleteChannel` or `All.deleteTeamsChannel`.
-   [List members of a channel](https://learn.microsoft.com/en-us/graph/api/channel-list-members?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Channel.getMembers` or `All.getTeamsChannelMembers`.
-   [Add member to channel](https://learn.microsoft.com/en-us/graph/api/channel-post-members?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Channel.addMember` or `All.addMemberToTeamsChannel`.
-   [Remove member from channel](https://learn.microsoft.com/en-us/graph/api/channel-delete-members?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Channel.removeMember` or `All.removeMemberFromTeamsChannel`.
-   [List channel messages](https://learn.microsoft.com/en-us/graph/api/channel-list-messages?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Channel.getMessages` or `All.getTeamsChannelMessages`.
-   [Send chatMessage in channel](https://learn.microsoft.com/en-us/graph/api/channel-post-messages?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Channel.sendMessage` or `All.sendTeamsChannelMessage`.
-   [Get chatMessage in a channel or chat](https://learn.microsoft.com/en-us/graph/api/chatmessage-get?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Channel.getMessage` or `All.getTeamsChannelMessage`.
-   [Update chatMessage](https://learn.microsoft.com/en-us/graph/api/chatmessage-update?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Channel.updateMessage` or `All.updateTeamsChannelMessage`.
-   [List replies](https://learn.microsoft.com/en-us/graph/api/chatmessage-list-replies?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Channel.getMessageReplies` or `All.getTeamsChannelMessageReplies`.
-   [Send replies to a message in a channel](https://learn.microsoft.com/en-us/graph/api/chatmessage-post-replies?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Channel.replyToMessage` or `All.replyToTeamsChannelMessage`.

# Added support for the following Teams.Messaging.Chat methods:

-   [List chats](https://learn.microsoft.com/en-us/graph/api/chat-list?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Chat.getChats` or `All.getTeamsChats`.
-   [Create chat](https://learn.microsoft.com/en-us/graph/api/chat-post?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Chat.createChat` or `All.createTeamsChat`.
-   [Get chat](https://learn.microsoft.com/en-us/graph/api/chat-get?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Chat.getChat` or `All.getTeamsChat`.
-   [Update chat](https://learn.microsoft.com/en-us/graph/api/chat-patch?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Chat.updateChat` or `All.updateTeamsChat`.
-   [List members of a chat](https://learn.microsoft.com/en-us/graph/api/chat-list-members?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Chat.getMembers` or `All.getTeamsChatMembers`.
-   [Add member to a chat](https://learn.microsoft.com/en-us/graph/api/chat-post-members?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Chat.addMember` or `All.addMemberToTeamsChat`.
-   [Get conversationMember in a chat](https://learn.microsoft.com/en-us/graph/api/chat-get-members?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Chat.getMember` or `All.getTeamsChatMember`.
-   [Remove member from chat](https://learn.microsoft.com/en-us/graph/api/chat-delete-members?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Chat.removeMember` or `All.removeTeamsChatMember`.
-   [List messages in a chat](https://learn.microsoft.com/en-us/graph/api/chat-list-messages?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Chat.getMessages` or `All.getTeamsChatMessages`.
-   [Send message in a chat](https://learn.microsoft.com/en-us/graph/api/chat-post-messages?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Chat.sendMessage` or `All.sendTeamsChatMessage`.
-   [Get chatMessage in a channel or chat](https://learn.microsoft.com/en-us/graph/api/chatmessage-get?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Chat.getMessage` or `All.getTeamsChatMessage`.
-   [Update chatMessage](https://learn.microsoft.com/en-us/graph/api/chatmessage-update?view=graph-rest-1.0&tabs=http) that can be used as `Teams.Messaging.Chat.updateMessage` or `All.updateTeamsChatMessage`.

Copyright Adaptavist 2025 (c) All rights reserved