/*!
 * Copyright Adaptavist 2022 (c) All rights reserved
 */
import { MicrosoftGraphAssignedLabelAsResponse } from "../definitions/MicrosoftGraphAssignedLabelAsResponse";
import { MicrosoftGraphAssignedLicenseAsResponse } from "../definitions/MicrosoftGraphAssignedLicenseAsResponse";
import { MicrosoftGraphLicenseProcessingStateAsResponse } from "../definitions/MicrosoftGraphLicenseProcessingStateAsResponse";
import { MicrosoftGraphOnPremisesProvisioningErrorAsResponse } from "../definitions/MicrosoftGraphOnPremisesProvisioningErrorAsResponse";
import { MicrosoftGraphAppRoleAssignmentAsResponse } from "../definitions/MicrosoftGraphAppRoleAssignmentAsResponse";
import { CountAsResponse } from "../definitions/CountAsResponse";
import { MicrosoftGraphDirectoryObjectAsResponse } from "../definitions/MicrosoftGraphDirectoryObjectAsResponse";
import { MicrosoftGraphResourceSpecificPermissionGrantAsResponse } from "../definitions/MicrosoftGraphResourceSpecificPermissionGrantAsResponse";
import { MicrosoftGraphGroupSettingAsResponse } from "../definitions/MicrosoftGraphGroupSettingAsResponse";
import { MicrosoftGraphCalendarAsResponse } from "../definitions/MicrosoftGraphCalendarAsResponse";
import { MicrosoftGraphEventAsResponse } from "../definitions/MicrosoftGraphEventAsResponse";
import { MicrosoftGraphConversationAsResponse } from "../definitions/MicrosoftGraphConversationAsResponse";
import { MicrosoftGraphConversationThreadAsResponse } from "../definitions/MicrosoftGraphConversationThreadAsResponse";
import { MicrosoftGraphDriveAsResponse } from "../definitions/MicrosoftGraphDriveAsResponse";
import { MicrosoftGraphSiteAsResponse } from "../definitions/MicrosoftGraphSiteAsResponse";
import { MicrosoftGraphExtensionAsResponse } from "../definitions/MicrosoftGraphExtensionAsResponse";
import { MicrosoftGraphGroupLifecyclePolicyAsResponse } from "../definitions/MicrosoftGraphGroupLifecyclePolicyAsResponse";
import { MicrosoftGraphPlannerGroupAsResponse } from "../definitions/MicrosoftGraphPlannerGroupAsResponse";
import { MicrosoftGraphOnenoteAsResponse } from "../definitions/MicrosoftGraphOnenoteAsResponse";
import { MicrosoftGraphProfilePhotoAsResponse } from "../definitions/MicrosoftGraphProfilePhotoAsResponse";
import { MicrosoftGraphTeamAsResponse } from "../definitions/MicrosoftGraphTeamAsResponse";
export interface MicrosoftGraphGroupAsResponse {
    id?: string;
    deletedDateTime?: string | null;
    assignedLabels?: Array<MicrosoftGraphAssignedLabelAsResponse>;
    assignedLicenses?: Array<MicrosoftGraphAssignedLicenseAsResponse>;
    classification?: string | null;
    createdDateTime?: string | null;
    description?: string | null;
    displayName?: string | null;
    expirationDateTime?: string | null;
    groupTypes?: Array<string>;
    hasMembersWithLicenseErrors?: boolean | null;
    isAssignableToRole?: boolean | null;
    licenseProcessingState?: MicrosoftGraphLicenseProcessingStateAsResponse | null;
    mail?: string | null;
    mailEnabled?: boolean | null;
    mailNickname?: string | null;
    membershipRule?: string | null;
    membershipRuleProcessingState?: string | null;
    onPremisesDomainName?: string | null;
    onPremisesLastSyncDateTime?: string | null;
    onPremisesNetBiosName?: string | null;
    onPremisesProvisioningErrors?: Array<MicrosoftGraphOnPremisesProvisioningErrorAsResponse>;
    onPremisesSamAccountName?: string | null;
    onPremisesSecurityIdentifier?: string | null;
    onPremisesSyncEnabled?: boolean | null;
    preferredDataLocation?: string | null;
    preferredLanguage?: string | null;
    proxyAddresses?: Array<string>;
    renewedDateTime?: string | null;
    securityEnabled?: boolean | null;
    securityIdentifier?: string | null;
    theme?: string | null;
    visibility?: string | null;
    allowExternalSenders?: boolean | null;
    autoSubscribeNewMembers?: boolean | null;
    hideFromAddressLists?: boolean | null;
    hideFromOutlookClients?: boolean | null;
    isSubscribedByMail?: boolean | null;
    unseenCount?: number | null;
    isArchived?: boolean | null;
    appRoleAssignments?: Array<MicrosoftGraphAppRoleAssignmentAsResponse>;
    "appRoleAssignments@odata.count"?: CountAsResponse;
    createdOnBehalfOf?: MicrosoftGraphDirectoryObjectAsResponse;
    memberOf?: Array<MicrosoftGraphDirectoryObjectAsResponse>;
    "memberOf@odata.count"?: CountAsResponse;
    members?: Array<MicrosoftGraphDirectoryObjectAsResponse>;
    "members@odata.count"?: CountAsResponse;
    membersWithLicenseErrors?: Array<MicrosoftGraphDirectoryObjectAsResponse>;
    "membersWithLicenseErrors@odata.count"?: CountAsResponse;
    owners?: Array<MicrosoftGraphDirectoryObjectAsResponse>;
    "owners@odata.count"?: CountAsResponse;
    permissionGrants?: Array<MicrosoftGraphResourceSpecificPermissionGrantAsResponse>;
    "permissionGrants@odata.count"?: CountAsResponse;
    settings?: Array<MicrosoftGraphGroupSettingAsResponse>;
    "settings@odata.count"?: CountAsResponse;
    transitiveMemberOf?: Array<MicrosoftGraphDirectoryObjectAsResponse>;
    "transitiveMemberOf@odata.count"?: CountAsResponse;
    transitiveMembers?: Array<MicrosoftGraphDirectoryObjectAsResponse>;
    "transitiveMembers@odata.count"?: CountAsResponse;
    acceptedSenders?: Array<MicrosoftGraphDirectoryObjectAsResponse>;
    "acceptedSenders@odata.count"?: CountAsResponse;
    calendar?: MicrosoftGraphCalendarAsResponse | null;
    calendarView?: Array<MicrosoftGraphEventAsResponse>;
    "calendarView@odata.count"?: CountAsResponse;
    conversations?: Array<MicrosoftGraphConversationAsResponse>;
    "conversations@odata.count"?: CountAsResponse;
    events?: Array<MicrosoftGraphEventAsResponse>;
    "events@odata.count"?: CountAsResponse;
    rejectedSenders?: Array<MicrosoftGraphDirectoryObjectAsResponse>;
    "rejectedSenders@odata.count"?: CountAsResponse;
    threads?: Array<MicrosoftGraphConversationThreadAsResponse>;
    "threads@odata.count"?: CountAsResponse;
    drive?: MicrosoftGraphDriveAsResponse | null;
    drives?: Array<MicrosoftGraphDriveAsResponse>;
    "drives@odata.count"?: CountAsResponse;
    sites?: Array<MicrosoftGraphSiteAsResponse>;
    "sites@odata.count"?: CountAsResponse;
    extensions?: Array<MicrosoftGraphExtensionAsResponse>;
    "extensions@odata.count"?: CountAsResponse;
    groupLifecyclePolicies?: Array<MicrosoftGraphGroupLifecyclePolicyAsResponse>;
    "groupLifecyclePolicies@odata.count"?: CountAsResponse;
    planner?: MicrosoftGraphPlannerGroupAsResponse | null;
    onenote?: MicrosoftGraphOnenoteAsResponse | null;
    photo?: MicrosoftGraphProfilePhotoAsResponse | null;
    photos?: Array<MicrosoftGraphProfilePhotoAsResponse>;
    "photos@odata.count"?: CountAsResponse;
    team?: MicrosoftGraphTeamAsResponse | null;
}
//# sourceMappingURL=MicrosoftGraphGroupAsResponse.d.ts.map